import * as i18nLogService from "../service/i18nlog.service";
import { I18nInfoLogVO } from "../service/i18nlog.service";

let { logger, ResponseUtils, optionalUtils: Optional, apiAssertUtils: ApiAssert } = require('@madex/ex-js-public');

/**
 * 国际化信息修改日志列表
 * @param req
 * @param infoVO
 */
export const list = async (req: any, i18nInfoLogVO: I18nInfoLogVO) => {
    let func_name = "i18nLogCtrl.list";
    let cmd = req.path;
    try {
        i18nInfoLogVO.page = Optional.opt(i18nInfoLogVO, 'page', 1);
        i18nInfoLogVO.size = Optional.opt(i18nInfoLogVO, 'size', 50);
        i18nInfoLogVO.platform = Optional.opt(i18nInfoLogVO, 'platform', 1);
        i18nInfoLogVO.module = Optional.opt(i18nInfoLogVO, 'module', 1);
        i18nInfoLogVO.lang = Optional.opt(i18nInfoLogVO, 'lang', 'en');
        let res = await i18nLogService.list(i18nInfoLogVO);
        return ResponseUtils.success(cmd, res);
    }
    catch (e) {
        logger.error(`${func_name} error:${e}`);
        return ResponseUtils.error(func_name, cmd, e);
    }
};
/**
 * 还原(还原到修改之前)
 * @param req
 * @param infoVO
 */
export const revert = async (req: any, i18nInfoLogVO: I18nInfoLogVO) => {
    let func_name = "i18nLogCtrl.revert";
    let cmd = req.path;
    try {
        ApiAssert.notNull('3000', i18nInfoLogVO.id);
        ApiAssert.notNull('3000', i18nInfoLogVO.info_id);
        let res = await i18nLogService.revert(i18nInfoLogVO);
        return ResponseUtils.success(cmd, res);
    }
    catch (e) {
        logger.error(`${func_name} error:${e}`);
        return ResponseUtils.error(func_name, cmd, e);
    }
};
